# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2001,2006 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# void _wbmsg([string ofile])
#
# Takes the _MSG[] array and builds the underlying CSA_WBMSG variable.
# The _MSG[] array is reset after it has been used, just in case.
#
# This function is currently only useful together with the 'csaSource'
# rc(1) library function.
# =====================================================================

function _wbmsg(ofile,					i,s) {

  if (ofile == "") ofile = _STDOUT
  else if (ofile !~ /^\/\.*[a-zA-Z0-9]/) return _EINVAL

  if (!(_MSG[0] /= 1)) return _ENOMSG		# nothing to do.

  if (_MSG[1] !~ /^[0-9][0-9][0-9][0-9]$/) return _EINVAL

  s = "~ $CSA_WBMSG () && {CSA_WBMSG=(" _MSG[1]

  for (i=2; i<=_MSG[0]; i++) s = s " " _rcescape(_MSG[i])

  _sys(s ")}",ofile)

  _MSG[0] = 0				# reset before returning.
}

